use std::error;
use std::fs::File;
use std::io::BufRead;
use std::io::BufReader;

const DEBUG: bool = false;

fn main() -> Result<(), Box<dyn error::Error>> {
	let f = File::open("input.txt")?;
	let reader = BufReader::new(f);

	let mut strength_sum = 0;
	let mut strength = 1;
	let mut cycle = 1;
	for line in reader.lines() {
		let line = line?;
		let mut split_iter = line.split_whitespace();
		let cmd = split_iter.next().ok_or("asdf")?;
		match cmd {
			"noop" => {
				cycle += 1;
				if (cycle % 40) == 20 {
					strength_sum += strength * cycle;
					if DEBUG {
						println!("{} {} {}", cycle, strength, strength * cycle)
					}
				}
			},
			"addx" => {
				cycle += 1;
				if (cycle % 40) == 20 {
					strength_sum += strength * cycle;
					if DEBUG {
						println!("{} {} {}", cycle, strength, strength * cycle)
					}
				}
				cycle += 1;
				let num: i32 = split_iter.next().ok_or("bla")?.parse()?;
				strength += num;
				if (cycle % 40) == 20 {
					strength_sum += strength * cycle;
					if DEBUG {
						println!("{} {} {}", cycle, strength, strength * cycle)
					}
				}
			},
			_ => Err(format!("Unknown command: {}", cmd))?
		};
	}

    println!("Signal strength is {}", strength_sum);
    Ok(())
}
